
*****************************************************************************
*
* Collapse allows large models to be run with half the number of periods that
* actually exist in the input data. To accomplish this NYRSPER, STARTYRS and
* STARTs have already been adjusted in COLSTART.INC.  The rest of the input
* is adjusted here, as necessary.
*
*****************************************************************************
*GG* V1.2b

PUT CLOG;
SCALAR GRDIV;
IF (COLLAPSE NE 0,

  PUT CLOG // ' ***** TRACE LOG - COLLAPSE GROWTH, IBOND & RESIDS  ***** ' //;
  LOOP (SEP(SRC,ENT,P),
    SEP_GRTID(SEP) = SEP_GRTID(SEP) * 2;

* adjust odd year growth by using one if exists or averaging
    IF (SUM(YEAR,SEP_TGR(SEP,YEAR)),
      LOOP(YEAR$(MOD(ORD(YEAR),2) NE 0 AND ORD(YEAR) GT 1),
        GRDIV = 1$SEP_TGR(SEP,YEAR) + 1$SEP_TGR(SEP,YEAR-1);
        SEP_TGR(SEP,YEAR)$GRDIV = (SEP_TGR(SEP,YEAR-1) + SEP_TGR(SEP,YEAR)) /
                                   GRDIV;
        PUT$SEP_TGR(SEP,YEAR-1)
             ' GROWTH VALUE ADJUSTED TO ' SEP_TGR(SEP,YEAR) ' FOR RESOUCE = '
               SRC.TL:<3,ENT.TL:<3,P.TL:<1 ' IN ' YEAR.TL /;
      );
    );
  );

  LOOP (TCH,
    TCH_LIFE(TCH) = TCH_LIFE(TCH) / 2;
    TCH_GRTID(TCH) = TCH_GRTID(TCH) * 2;

* adjust odd year growth by using one if exists or averaging
    IF (SUM(YEAR,TCH_TGR(TCH,YEAR)),
      LOOP(YEAR$(MOD(ORD(YEAR),2) NE 0 AND ORD(YEAR) GT 1),
        GRDIV = 1$TCH_TGR(TCH,YEAR) + 1$TCH_TGR(TCH,YEAR-1);
        TCH_TGR(TCH,YEAR)$GRDIV = (TCH_TGR(TCH,YEAR-1) + TCH_TGR(TCH,YEAR)) /
                                   GRDIV;
        PUT$TCH_TGR(TCH,YEAR-1)
            ' GROWTH VALUE ADJUSTED TO ' TCH_TGR(TCH,YEAR) ' FOR TECHNOLOGY = '
              TCH.TL:<3 ' IN ' YEAR.TL/;
      );
    );

* adjust odd year investment bounds
    IF (SUM((YEAR,BD),TCH_IBND(TCH,BD,YEAR)),
      LOOP((YEAR,BD)$(MOD(ORD(YEAR),2) NE 0 AND ORD(YEAR) GT 1),
        TCH_IBND(TCH_BD2(TCH,BD),YEAR) = TCH_IBND(TCH,BD,YEAR-1) +
                                         TCH_IBND(TCH,BD,YEAR);
        PUT$TCH_IBND(TCH,BD,YEAR-1)
          ' INVESTMENT BOUND ADJUSTED TO ' TCH_IBND(TCH,BD,YEAR)
          ' FOR TECHNOLOGY = ' TCH.TL:<3 ' IN ' YEAR.TL:<4 ', TYPE ' BD.TL:<2 /;
      );
    );
  );

*GG* V1.3b average GROWV if collapsing (added code)
  IF (SUM(YEAR,GROWV(YEAR)),
    LOOP(YEAR$((MOD(ORD(YEAR),2) NE 0) AND (ORD(YEAR) NE CARD(YEAR))),
      GROWV(YEAR) = (GROWV(YEAR+1) + GROWV(YEAR)) / 2;
      PUT ' GDP GROWTH VALUE ADJUSTED TO ' GROWV(YEAR) ' IN ' YEAR.TL/;
    );
  );

* dump out the RESIDs as a reminder for the user
  PUT / ' ***** RESIDUALS REMINDER *****' ;
  PUT / @26 LOOP(TP, PUT TP.TL:>10) ;
  LOOP(TCH$SUM(TP,TCH_RESID(TCH,TP)),
    PUT / 'RESIDs FOR TECHNOLOGY = ' TCH.TL:<3,
    LOOP(TP, PUT TCH_RESID(TCH, TP));
  );

);



--Boundary_(ID_sfgA27vcFPhhWTQF8mTgVw)--
