*******************************************************************************
* filltab3 %1 %2 %3
*
* Description: Fill all rows of a three-dimensional time-dependant table
*              via linear interpolation
*
* Parameters:
*      %1 - table name
*      %2 - row set1 (or combined set)
*      %3 - row set2 (or combined set)
*
*******************************************************************************
*GG* V1.0g adjust to use YEAR (provided by the user in *.GEN file!)
$OFFLISTING
*GG* V1.1c add conditional interpolation flag
IF ((NOINTERP NE 1),
  LOOP(%3,
  LOOP(%2,
*GG* V1.2a introduce Ken Noble's tempary array to speed filling
    F=0; FIL(YEAR) = NO; FIL2(YEAR)=0; TEMPARRAY(YEAR) = %1(%2,%3,YEAR);
    LOOP(YEAR,
         IF(TEMPARRAY(YEAR),  ! check for nonzero (including EPS)
           IF(F, TEMPARRAY(FIL) =
              F + (TEMPARRAY(YEAR)-F)/(CARD(FIL)+1)*FIL2(FIL)); ! not the first one
           FIL(FIL) = NO; ! clear set s
           F=TEMPARRAY(YEAR)     ! remember the value
         ELSE
           FIL(YEAR) = YES;     ! remember position
           FIL2(YEAR) = CARD(FIL)  ! save current length - distanmce from first
         )
    );
    %1(%2,%3,YEAR) = TEMPARRAY(YEAR);
  );
  );
);
*GG*? need to deal with START too
