*$OFFLISTING
*******************************************************************************
*                                                                             *
*  This is the MARKAL-MACRO report writer.  GAMS PUT statements are used to   *
*   output results in a standard format for importing into MUSS.  Since the   *
*   PUT statement does not allow any calculations to be performed they must   *
*   be done beforehand and stored in intermediate tables.  The PARAMETERS     *
*   are declared and initialized in MMINIT.INC.                               *
*                                                                             *
*   DISPLAY statements direct output to the *.LST file for the current run.   *
*                                                                             *
*******************************************************************************
*GG* V1.0h change the hardwire .001/1000 scaling to use MMSCALE
*GG* V1.1b introduce BATINCLUDE MUSS printer routines

*GG* V1.4a modularize so that routine can be used when iterating
$INCLUDE RWSETUP.MM

*=============================================================================*
*  Calculate Demands Adjusted for AEEI                                        *
*=============================================================================*
*GG* V1.4a moved to RWSETUP.MM

*=============================================================================*
*  Calculate Gross Domestic Product                                           *
*=============================================================================*
*GG* V1.4a moved to RWSETUP.MM

*=============================================================================*
*  Calulate Total Consumption                                                 *
*=============================================================================*
*GG* V1.4a moved to RWSETUP.MM

*=============================================================================*
*  Set Trigger Flags for Capital, Demand and Investment/Energy Costs          *
*=============================================================================*
*GG* V1.4a moved to RWSETUP.MM

*=============================================================================*
*  Get Any Technolgies Which Had Market Penetration Cost Penalties Applied    *
*=============================================================================*
*PARAMETERS XCAPREP(TCH,TP) market penetration bounds - additional capacity
*           /EMPTY.EMPTY 0/;
  XCAPREP(TCH,TP) = XCAP.L(TP,TCH);
DISPLAY XCAPREP;

*=============================================================================*
*  Calculate the Marginal Cost of Demands                                     *
*=============================================================================*
*PARAMETERS MC(DM,TP) MARGINAL COSTS OF ENERGY DEMANDS - DOLLARS PER GJ
*           / EMPTY.EMPTY 0 /;
  MC(TP,DM)       = - SP.M(DM,TP) / COSTNRG.M(TP) * (MMSCALE/.001);

*=============================================================================*
*  Report Gross Domestic Product, Consumption, Investment and Energy Costs    *
*=============================================================================*
*GG* V1.4a moved to RWSETUP.MM

AT.NW=10;AT.ND=2;
*=============================================================================*
*  Marginal Costs of Demands plus                                             *
*  Difference Between Input PREFs and Marginal Costs of Demands in 2nd Period *
*=============================================================================*
*GG* V1.0a put out the PREFDIFF
DDAT(DM,'DIFF') = SUM(TP$(ORD(TP) EQ 2), MC(TP,DM))-DDAT(DM,'PREF');
PUT / @10,'TABLE MC' /;PUT @26 'PREFDIFF' @34 ;
  LOOP (TP, PUT TP.TL:>10);
  LOOP (DM, PUT / @7,DM.TL:<9,@24;
        PUT DDAT(DM,'DIFF') @34;
        LOOP (TP, PUT MC(TP,DM)));

*  Adjust number of decimals for reporting the MACRO results
AT.NW=10;AT.ND=3;
*=============================================================================*
*  MACRO Summary Table                                                        *
*   - Gross Domestic Product                                                  *
*   - Investment                                                              *
*   - Capital                                                                 *
*   - Cost of Energy                                                          *
*   - Total Demand                                                            *
*=============================================================================*
  PUT / @10 'TABLE GDP'
      /                @22; LOOP (TP, PUT TP.TL:>10);
  PUT / @7  '.GDP'     @24; LOOP (TP, PUT GDP(TP));
  PUT / @7  '.IV'      @24; LOOP (TP, PUT IV.L(TP));
  PUT / @7  '.K'       @24; LOOP (TP, PUT K.L(TP));
  PUT / @7  '.EC'      @24; LOOP (TP, PUT EC.L(TP));
  PUT / @7  '.TDM'     @24; LOOP (TP, PUT SUM(DM, AD(TP,DM)));
