******************************************************************************
*                                                                            *
*  MARKAL Related Variables                                                  *
*                                                                            *
******************************************************************************

POSITIVE VARIABLES
*=============================================================================*
*  Activities of Energy Carriers                                              *
*=============================================================================*
  TSEP(TP, SRC, ENT, P)

*=============================================================================*
*  Annual Carry-over From the Final Time Period of Stockpiled Material        *
*=============================================================================*
  ZSTK(ENC, P)

*=============================================================================*
*  Annual Activity of Processes in Each Time Period                           *
*=============================================================================*
  ACT(TP, PRC)

*=============================================================================*
*  Annual Activity of Limit Processes for each Energy Carrier                 *
*=============================================================================*
*GG* V1.1a add
  LOUT(TP, PRC, ENC)

$ONTEXT
*=============================================================================*
*  LIMIT Vectors for Processes, if Activated                                  *
*=============================================================================*
  TPE(TP, PRC, ENC)
$OFFTEXT

*=============================================================================*
*  Installed Capacity of Technologies in Each Time Period                     *
*=============================================================================*
  CAP(TP, TCH)

*=============================================================================*
*  Incremental Capacity of Technologies Added in Each Time Period             *
*=============================================================================*
  INV(TP, TCH)

*=============================================================================*
*  Scheduled Maintenance in a Season for a Conversion Technology              *
*=============================================================================*
*GG* V1.1a add scheduled maintenance for conversion technologies
  M(TP, CON, Z)

*=============================================================================*
*  Annual Production of Electricity in Each Time Period for Each Season/      *
*   Time-of-Day                                                               *
*=============================================================================*
  TEZY(TP, TCH, Z, Y)

*=============================================================================*
*  Annual Production of Low-Temperature Heat in Each Time Period for each     *
*   Season from Heating Plants                                                *
*=============================================================================*
*GG* V1.0e add HPL activity variable
  THZ(TP, TCH, Z)

*=============================================================================*
*  Annual Production of Low-Temperature Heat in Each Time Period for each     *
*   Season from Coupled Production plants                                     *
*=============================================================================*
*GG* V1.1a add CPD heat activity variable
  TCZYH(TP, TCH, Z, Y)

*=============================================================================*
*  Annual Accounting of Emissions Indicators                                  *
*=============================================================================*
  EM(TP, ENV)

*=============================================================================*
*GG* V1.4e  Balance variable for Energy Carrier Tax/Subsidy                   *
*=============================================================================*
  TXSUB(TP, TAXSUB)

*=============================================================================*
*  Objective Function Value                                                   *
*=============================================================================*
VARIABLES
  objZ
;
